Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.instruct
Class Doctype

    java.lang.Object
      net.sf.saxon.expr.ComputedExpression
          net.sf.saxon.instruct.Instruction
              net.sf.saxon.instruct.Doctype

All Implemented Interfaces:
  Container, Expression, InstructionInfoProvider, java.io.Serializable, javax.xml.transform.SourceLocator

public class Doctype
extends Instruction

A saxon:doctype element in the stylesheet.

See Also:
  Serialized Form

Field Summary

Fields inherited from class net.sf.saxon.expr.ComputedExpression
`locationId, staticProperties`

Fields inherited from interface net.sf.saxon.expr.Expression
`EVALUATE_METHOD, ITERATE_METHOD, PROCESS_METHOD`

Constructor Summary
`Doctype(Expression content)`

Method Summary
`Expression` | `analyze(StaticContext env, ItemType contextItemType)` Perform static analysis of an expression and its subexpressions.
`boolean` | `createsNewNodes()` Determine whether this instruction creates new nodes.
`void` | `display(int level, NamePool pool, java.io.PrintStream out)` Diagnostic print of expression structure.
`int` | `getInstructionNameCode()` Get the name of this instruction for diagnostic and tracing purposes
`TailCall` | `processLeavingTail(XPathContext context)` ProcessLeavingTail: called to do the real work of this instruction.
`protected void` | `promoteInst(PromotionOffer offer)` Handle promotion offers, that is, non-local tree rewrites.
`Expression` | `simplify(StaticContext env)` Simplify an expression.

Methods inherited from class net.sf.saxon.instruct.Instruction
`appendItem, assembleParams, assembleTunnelParams, computeCardinality, computeSpecialProperties, dynamicError, dynamicError, effectiveBooleanValue, evaluateAsString, evaluateItem, getImplementationMethod, getInstructionInfo, getItemType, getSourceLocator, isXSLT, iterate, process, promote`

Methods inherited from class net.sf.saxon.expr.ComputedExpression
`adoptChildExpression, checkPermittedContents, computeDependencies, computeStaticProperties, dynamicError, dynamicError, getCardinality, getColumnNumber, getConstructType, getDependencies, getExecutable, getIntrinsicDependencies, getLineNumber, getLocationId, getParentExpression, getPublicId, getSpecialProperties, getSystemId, iterateSubExpressions, markTailFunctionCalls, resetStaticProperties, setLocationId, setParentExpression, typeError, typeError`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface javax.xml.transform.SourceLocator
`getColumnNumber, getLineNumber, getPublicId, getSystemId`

Constructor Detail

### Doctype

    public Doctype(Expression content)

Method Detail

### simplify

    public Expression simplify(StaticContext env)
                        throws XPathException

  Simplify an expression. This performs any static optimization (by rewriting the expression as a different expression). The default implementation does nothing.

  Specified by:
    `simplify` in interface `Expression`
  Specified by:
    `simplify` in class `Instruction`
  Returns:
    the simplified expression
  Throws:
    `XPathException` - if an error is discovered during expression rewriting

### analyze

    public Expression analyze(StaticContext env,
                              ItemType contextItemType)
                       throws XPathException

  Perform static analysis of an expression and its subexpressions.

  This checks statically that the operands of the expression have the correct type; if necessary it generates code to do run-time type checking or type conversion. A static type error is reported only if execution cannot possibly succeed, that is, if a run-time type error is inevitable. The call may return a modified form of the expression.

  This method is called after all references to functions and variables have been resolved to the declaration of the function or variable. However, the types of such functions and variables will only be accurately known if they have been explicitly declared.

  Specified by:
    `analyze` in interface `Expression`
  Specified by:
    `analyze` in class `Instruction`
  Parameters:
    `env` - the static context of the expression
  Returns:
    the original expression, rewritten to perform necessary run-time type checks, and to perform other type-related optimizations
  Throws:
    `XPathException` - if an error is discovered during this phase (typically a type error)

### promoteInst

    protected void promoteInst(PromotionOffer offer)
                        throws XPathException

  Handle promotion offers, that is, non-local tree rewrites.

  Overrides:
    `promoteInst` in class `Instruction`
  Parameters:
    `offer` - The type of rewrite being offered
  Throws:
    `XPathException`

### createsNewNodes

    public final boolean createsNewNodes()

  Determine whether this instruction creates new nodes. This implementation returns true.

  Overrides:
    `createsNewNodes` in class `Instruction`

### getInstructionNameCode

    public int getInstructionNameCode()

  Get the name of this instruction for diagnostic and tracing purposes

  Overrides:
    `getInstructionNameCode` in class `Instruction`

### processLeavingTail

    public TailCall processLeavingTail(XPathContext context)
                                throws XPathException

  Description copied from class: `Instruction`
  ProcessLeavingTail: called to do the real work of this instruction. This method must be implemented in each subclass. The results of the instruction are written to the current Receiver, which can be obtained via the Controller.

  Specified by:
    `processLeavingTail` in class `Instruction`
  Parameters:
    `context` - The dynamic context of the transformation, giving access to the current node, the current variables, etc.
  Returns:
    null if the instruction has completed execution; or a TailCall indicating a function call or template call that is delegated to the caller, to be made after the stack has been unwound so as to save stack space.
  Throws:
    `XPathException`

### display

    public void display(int level,
                        NamePool pool,
                        java.io.PrintStream out)

  Diagnostic print of expression structure. The expression is written to the System.err output stream

  Parameters:
    `level` - indentation level for this expression
    `out` -
    `pool` - NamePool used to expand any names appearing in the expression

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD